/*
-------------------
MesaScript
by Wolfie!
28 August, 2009
-------------------
*/

AddCSLuaFile( "cl_init.lua" )
AddCSLuaFile( "cl_mainmenu.lua" )
AddCSLuaFile( "shared.lua" )
AddCSLuaFile( "specialchars.lua" )
AddCSLuaFile( "cl_hud.lua" )
AddCSLuaFile( "client/cl_label.lua" )
AddCSLuaFile( "sh_label.lua" )
AddCSLuaFile( "MesaWorks/cv_cl_init.lua" )

/* Materials needed for MesaWorks!!! */
resource.AddFile( "materials/vote/check.vmt" )
resource.AddFile( "materials/vote/check.vtf" )
resource.AddFile( "materials/vote/cross.vmt" )
resource.AddFile( "materials/vote/cross.vtf" )
resource.AddFile( "materials/vote/checkLarge.vmt" )
resource.AddFile( "materials/vote/checkLarge.vtf" )
resource.AddFile( "materials/vote/crossLarge.vmt" )
resource.AddFile( "materials/vote/crossLarge.vtf" )

include( 'shared.lua' )
include( 'specialchars.lua' )
include( 'sqlfunc.lua' )
//include( 'map_spawnents.lua' )
include( "MesaWorks/config.lua" )
include( "MesaWorks/cv_init.lua" )

//local ply = LocalPlayer() 
RunConsoleCommand("mp_falldamage", "1")

local rp = RecipientFilter()     -- Grab a RecipientFilter object
rp:AddAllPlayers()               -- Send to all players!
/*
function GM:Initialize()
	surface.CreateFont( "comic", 48, 500, true, true, "ComicSansMS" )
	surface.CreateFont( "tahoma", 48, 500, true, true, "Tahoma" )
	surface.CreateFont( "segoeui", 48, 500, true, true, "SegoeUI" )
end
*/
function GM:PlayerSpawn( ply )
    self.BaseClass:PlayerSpawn( ply )   
 
    ply:SetGravity( 0.75 )  
    ply:SetMaxHealth( 100, true )  
 
    ply:SetWalkSpeed( 250 )  
	ply:SetRunSpeed( 800 ) 
end

function GM:PlayerInitialSpawn( ply )
	timer.Create("Steam_id_delay", 1, 1, function()
		SteamID = ply:SteamID()
		ply:SetNWString("SteamID", SteamID)
		//timer.Create("SaveStat", 10, 0, function() saveStat( ply ) end)
		//player_exists( ply ) 
	end)
	
	function setupTitle( pl )
		if( !label.ConVars.Enabled:GetBool( ) ) then return; end
		if( !IsValid( pl ) ) then return; end
		
		if( pl:SteamID( ) == "STEAM_ID_PENDING" ) then
			timer.Simple( 0.01, setupTitle, pl );
		else
			local title = pl:GetPData( "m_CustomTitle" );
			local messages, message = label.ConVars.ShowMessages:GetBool( );
			
			if( !title or title == "" ) then
				message = string.format( "[label] You don't have a custom title, type %q to set it.", label.GetCommandString( ) );
			else
				pl:SetCustomTitle( title );
				message = string.format( "[label] Your custom title is set to %q.", title );
			end
			
			if( messages ) then pl:ChatPrint( message ); end
		end
	end
	umsg.Start("startup_welcomemessage", rp)
	umsg.End()
end

function GM:PlayerLoadout( ply ) // What should the player recieve when joining a team?
	if ply:Team() == 1 then //If he is team 1, then give him the following items
		ply:Give( "weapon_physgun" ) // A Physics gun
		//ply:Give( "weapon_physcannon" )
		//ply:Give( "gmod_tool" ) // and don't forget the tool gun!
		ply:Give( "weapon_real_cs_five-seven", true )
	elseif ply:Team() == 2 then // So if he isn't team 1, he could be team 2?
		//ply:Give( "weapon_physgun" ) // Physics gun
		//ply:Give( "weapon_physcannon" )
		//ply:Give( "gmod_tool" ) // and the gmod tool
		ply:Give( "weapon_real_cs_tmp" )
		ply:Give( "weapon_real_cs_five-seven", true )
		ply:Give( "weapon_real_cs_knife" )
		ply:GiveAmmo( "pistol", 250 )
		ply:GiveAmmo( "smg1", 250 )
	end
end

function sb_team1( ply ) //This is what happens when we enter sb_team1 into the console.
	ply:UnSpectate() //Since he was set to spectate until he presses the 'hell yeah' button, we now unspecatate him
	ply:SetTeam( 1 ) //We set his team to one, a.k.a 'guest'
	ply:Spawn() //Spawn the player
	ply:PrintMessage( HUD_PRINTTALK, "[MesaWorks]Welcome to the server, " .. ply:Nick() ) //Gives the message [SimpleBuild]Welcome to the server, (playername here)"  in the talk area.
end //End the function.

function sb_team2( ply ) // Function sb_team2. Called at the beginning
	// Why no unspectate? Look carefully at the GM:PlayerSpawn; We only call to spectate after we see if he's an admin. Assuming he's always ready to build, I chose to skip it.	
	ply:SetTeam( 2 ) //Set his team to team 2.
	ply:Spawn() // Spawn him
	ply:PrintMessage( HUD_PRINTTALK, "[MesaWorks]I recognize you as an admin, " .. ply:Nick() ) //Again, a message in the talk area. 
	//This time saying "[SimpleBuild] I recognize you as an admin (playername here)" 
end //End this function
concommand.Add( "sb_team1", sb_team1 )
concommand.Add( "sb_team2", sb_team2 )

local files = file.Find( "../materials/ichat/smilies/*.*" )
for k, v in pairs( files ) do
	resource.AddFile( "materials/ichat/smilies/"..v )
end

/*---------------------------------------------------------
	Purpose: load the player's custom title and display
	the intro messages
---------------------------------------------------------*/
/*
function label.PlayerInitialSpawn( pl )
	
end
hook.Add( "PlayerInitialSpawn", "label.PlayerInitSpawn", label.PlayerInitialSpawn );
*/
/*---------------------------------------------------------
	Purpose: get the usage string of the command that sets
	the player's title
---------------------------------------------------------*/
function label.GetCommandString( )
	
	local prefix = label.ConVars.ChatPrefix:GetString( );
	local command = label.ConVars.ChatCommand:GetString( );
	
	return( prefix..command.." <title>" );
	
end

/*---------------------------------------------------------
	Purpose: extract the chat command, process it and set
	the player's title if needed
---------------------------------------------------------*/
function label.PlayerSay( pl, text )
	
	if( !label.ConVars.Enabled:GetBool( ) ) then return; end
	
	local command = label.ConVars.ChatCommand:GetString( ):lower( );
	
	local prefix = label.ConVars.ChatPrefix:GetString( ):lower( );
	if( text:sub( 1, #prefix ):lower( ) != prefix ) then return; end
	
	text = text:sub( #prefix + 1 );
	
	local command_name = text:sub( text:find( "[%w_]+" ) );
	if( command_name:lower( ) != command ) then return; end
	
	local title = text:sub( #command_name + 1 ):Trim( );
	local messages, message = label.ConVars.ShowMessages:GetBool( );
	
	pl:SetCustomTitle( title );
	
	if( title == "" ) then
		
		message = "[label] Your custom title is set to nothing.";
		
	else message = string.format( "[label] Your custom title is set to %q.", title ); end
	
	pl:ChatPrint( message );
	
	return "";
	
end
hook.Add( "PlayerSay", "label.PlayerSay", label.PlayerSay );
